/*
 * avr90usb.h
 *
 * Created: 2012/06/16 18:35:08
 *  Author: tanaka
 */ 


#ifndef AVR90USB_H_
#define AVR90USB_H_

// Used if VBUS_SENSING_IO is defined as "ENABLED"
//#define   VBUS_SENSE_PORT        PORTC   // PORTx
//#define   VBUS_SENSE_PIN         PINC    // PINx
//#define   VBUS_SENSE_DDR         DDRC    // DDRx
//#define   VBUS_SENSE_IO          4       // 0...7
      //! @}

      //! @defgroup STK_526_leds Leds Management
      //! Macros to manage Leds on stk526
      //! @{

//
// PORT MAP
//
// CDS SENSER
#define CDS_PIN		PINC	// CDS SENSOR
#define CDS_PORT	PORTC	// CDS SENSOR
#define CDS_DS		7		// DATA SELECT	/ OUT
#define CDS_CLK		6		// CLOCK		/ OUT
#define CDS_DATA	5		// DATA			/ IN
#define DDRC_CDS	((1<<CDS_DS)|(1<<CDS_CLK))
#define INIT_CDS	(0)

// POWER SENSER
#define PW_PIN		PINC
#define PW_ALERT	4		// DATA			/ IN
#define PW_DOWN		2		// DATA			/ IN
#define DDRC_PW		(0)
#define INIT_PW		(0)


// SHIFT LED
#define LED_PORT	PORTD	// 
#define LED_L0		7		// OUT
#define LED_L1		6		// OUT
#define LED_L2		5		// OUT
#define LED_L3		4		// OUT
#define LED_L4		3		// OUT
#define LED_L5		2		// OUT
#define LED_L6		1		// OUT
#define DDRD_LED	((1<<LED_L0)|(1<<LED_L1)|(1<<LED_L2)|(1<<LED_L3)|(1<<LED_L4)|(1<<LED_L5)|(1<<LED_L6))
#define INIT_LED	0

#define portB_init() (DDRB = 0, PORTB = 0)
#define portC_init() (DDRC = (DDRC_CDS|DDRC_PW), PORTC = (INIT_CDS|INIT_PW))
#define portD_init() (DDRD = (DDRD_LED), PORTD = (INIT_LED))
#define ports_init() (portB_init(), portC_init(), portD_init())

#define LedOn(n)	(LED_PORT |= (1<<(7-(n))))
#define LedOff(n)	(LED_PORT &= ~(1<<(7-(n))))
/*
#define  LED_PORT  PORTD
#define  LED_DDR   DDRD
#define  LED_PIN   PIND

#define  LED0_BIT  PIND0
#define  LED1_BIT  PIND1
#define  LED2_BIT  PIND4
#define  LED3_BIT  PIND5


#define  Leds_init()             (LED_DDR  |=  (1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT), Leds_off())
#define  Leds_on()               (LED_PORT |=  (1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT))
#define  Leds_off()              (LED_PORT &= ~((1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT)))
#define  Leds_set_val(c)         (Leds_off(),LED_PORT |= (c<<4)&((1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT)))
#define  Leds_get_val()          (LED_PORT>>4)
                                
#define  Led0_on()               (LED_PORT |=  (1<<LED0_BIT))
#define  Led1_on()               (LED_PORT |=  (1<<LED1_BIT))
#define  Led2_on()               (LED_PORT |=  (1<<LED2_BIT))
#define  Led3_on()               (LED_PORT |=  (1<<LED3_BIT))
#define  Led0_off()              (LED_PORT &= ~(1<<LED0_BIT))
#define  Led1_off()              (LED_PORT &= ~(1<<LED1_BIT))
#define  Led2_off()              (LED_PORT &= ~(1<<LED2_BIT))
#define  Led3_off()              (LED_PORT &= ~(1<<LED3_BIT))
#define  Led0_toggle()           (LED_PIN  |=  (1<<LED0_BIT))
#define  Led1_toggle()           (LED_PIN  |=  (1<<LED1_BIT))
#define  Led2_toggle()           (LED_PIN  |=  (1<<LED2_BIT))
#define  Led3_toggle()           (LED_PIN  |=  (1<<LED3_BIT))
#define  Is_led0_on()            (LED_PIN  &   (1<<LED0_BIT) ? TRUE : FALSE)
#define  Is_led1_on()            (LED_PIN  &   (1<<LED1_BIT) ? TRUE : FALSE)
#define  Is_led2_on()            (LED_PIN  &   (1<<LED2_BIT) ? TRUE : FALSE)
#define  Is_led3_on()            (LED_PIN  &   (1<<LED3_BIT) ? TRUE : FALSE)
*/

#endif /* AVR90USB_H_ */